﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ItemsSourceSwitch
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private int _state = 1;
        readonly ItemSourceContainer<DataItem> _dataSource;

        public MainWindow()
        {
            InitializeComponent();

            var collection1 = Enumerable.Range(0, 100).Select(i => new DataItem(i));
            var collection2 = Enumerable.Range(101, 100).Select(i => new DataItem(i));

            this._dataSource = new ItemSourceContainer<DataItem>(
                0, 
                new ObservableCollection<DataItem>(collection1),
                new ObservableCollection<DataItem>(collection2));

            this.xamlGrid.ItemsSource = this._dataSource;
        }

        private void ButtonBase_OnClick(object sender, RoutedEventArgs e)
        {
            this._dataSource.ActiveCollectionIndex = _state++ % 2;
        }
    }

    public class DataItem
    {
        public DataItem(int id)
        {
            this.IntData = id;
            this.StringData = "String data " + id.ToString();
        }
        public string StringData { get; set; }
        public int IntData { get; set; }
    }
}
